/*
 * @(#)SadissComboBoxEditor.java 1.0 10/24/2002
 * Copyright 2002 Senamirmir Project
 *
 * You may distribute and/or modify Sadiss under the conditions 
 * of the LaTeX Project Public License. The license is located at
 * http://www.latex-project.org/lppl.txt
 */

package keffa ;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import javax.swing.border.*;

/**
 * <!-- ----------------------------------------------------------------------- -->
 * SadissComboBoxEditor is used for font selection
 * @author abass alamene
 * @version 1.0 10/24/2002
 * <!-- ----------------------------------------------------------------------- -->
 */

public class SadissComboBoxEditor implements ComboBoxEditor {
   JTextField textField = null ;
   EditPanel panel = null ;
   int size = 0 ;

   public SadissComboBoxEditor(String defaultItem, int size) {
      panel = new EditPanel(defaultItem) ;
      this.size = size ;
   }


   public void setItem(Object anObject) {
      if (anObject != null) {
         panel.setText(anObject.toString()) ;
      } 
   }

   public Component getEditorComponent() { return panel; }
   public Object getItem() { return panel.getText(); }
   public void selectAll() { panel.selectAll(); }

   public void addActionListener(ActionListener l) {
     panel.addActionListener(l); 
   }

   public void removeActionListener(ActionListener l) {
     panel.removeActionListener(l); 
   }

   /**
    * <!-- ----------------------------------------------------------------------- -->
    * EditPanel is an inner class it defines the combobox interface
    * <!-- ----------------------------------------------------------------------- -->
    */
   class EditPanel extends JPanel {      
      JTextField textField = new JTextField(size) ;

      EditPanel(String text)  {
         setLayout(new GridLayout(1,1)) ;

	      Dimension d = new Dimension(size, 12) ;
	      setPreferredSize(d) ;
	      textField.setMinimumSize(d) ;

         textField = new JTextField(text);

         textField.setBorder(new BevelBorder(BevelBorder.LOWERED));
         add(textField);          
     }

   public void setText(String s) { textField.setText(s) ; }
   public String getText() { return (textField.getText()) ; }
   public void selectAll() { textField.selectAll(); }
   public void addActionListener(ActionListener l) {textField.addActionListener(l); }
   public void removeActionListener(ActionListener l) { textField.removeActionListener(l); }
   }
} 