/*
 * @(#)SadissComboBoxEditor.java 1.0 10/24/2002
 * Copyright 2002 Senamirmir Project
 *
 * You may distribute and/or modify Sadiss under the conditions 
 * of the LaTeX Project Public License. The license is located at
 * http://www.latex-project.org/lppl.txt
 */

package keffa ;

import java.awt.* ;
import javax.swing.* ;
import javax.swing.text.* ;
import java.awt.print.*;

/**
 * <!-- ----------------------------------------------------------------------- -->
 * SadissMenu is a subclass of JMenu. It adds antialias and set font
 * @author abass alamnehe
 * @version 1.0 10/24/2002
 * <!-- ----------------------------------------------------------------------- -->
 */

class SadissMenu extends JMenu {

   /**
    * Constructor
    * @param item menu item name
    */
   SadissMenu(String item) { 
      super(item) ;
      setFont(SadissJournal.getDefaultFont()) ;
   }

   /**
    *  Constructor
    * @param an instance of a subclass to AbstractAction class
    */
   SadissMenu(Action action) { 
      super(action) ;
      setFont(SadissJournal.getDefaultFont()) ;
   }

   /**
    * Implements antialias
    * @param g device context
    */
   public void paintComponent(Graphics g) {
      Graphics2D g2 = (Graphics2D) g;
      g2.setRenderingHint(
         RenderingHints.KEY_TEXT_ANTIALIASING,RenderingHints.VALUE_TEXT_ANTIALIAS_ON);
      super.paintComponent(g2);
   }
}
