/*
 * @(#)SadissComboBoxEditor.java 1.0 10/24/2002
 * Copyright 2002 Senamirmir Project
 *
 * You may distribute and/or modify Sadiss under the conditions 
 * of the LaTeX Project Public License. The license is located at
 * http://www.latex-project.org/lppl.txt
 */

package keffa ;

/**
 * <!-- ----------------------------------------------------------------------- -->
 * SadissStringMatch is a class that performs string matching
 * @author abass alamnehe
 * @version 1.0 10/24/2002
 * <!-- ----------------------------------------------------------------------- -->
 */

public class SadissStringMatch {
   private final int MAXCHARS = 5000 ;
   private String text ;
   private String pattern ;

   /**
    * Constructor
    * @param text the decomunet where the pattern will be searched
    * @param pattern a key
    */
   public SadissStringMatch(String text, String pattern) {
       this.text   = text ;
       this.pattern = pattern ;
   }

   /**
    * Performs a string matching and returns index
    * @param text the decomunet where the pattern will be searched
    * @param pattern a key
    */      
   int SadissSearch() {
      int n  = text.length() - 1 ; 			// 2 ;
      int m  = pattern.length() - 1 ; 			// 2 ;
      int[] skip = new int[MAXCHARS] ;

         // initialization of array from 0 to 5000
      for (int i = 0; i < MAXCHARS; i++)
         skip[i] = m + 1 ;

         // initialization of array for pattern string
      for (int i = 0; i <= m; i++)
         skip[ pattern.charAt(i) ] = m - i ;

         // initialization of array for pattern string
      for (int i = 0; i <= m; i++)
         System.out.println(".... " + skip[ pattern.charAt(i) ] );


         // now process and determine the result
      int tr = 0, pr = 0, tc = 0 ;

      try {
         for (tr = m; tr < n; tr += skip[ text.charAt(tr) ]) {
            //         System.out.println( text.substring(tr, text.length()) ) ;
            for (pr = m, tc = tr; pr >=0 && pattern.charAt(pr) == text.charAt(tc); pr--, tc--) 
               tr++;

            if (pr == -1)
               return ( ++tc ) ;
         }
      } catch (Exception msg) {
         System.out.println("SadissSearch: " + msg) ; 
      }
      return -1 ;
   }
} 
